<script lang="ts">
import Vue from 'vue';
import {
  CtfEntry,
  CtfTheSourceArticlePage,
  CtfTheSourceAuthor,
} from '~/models';
import { TheSourceService } from '~/services';
import {
  getAvailableLanguagesFromTags,
  getUrlFromContentfulImage,
  kebabToTitleCase,
} from '~/common/util';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { ContentfulLivePreview } from '@contentful/live-preview';
import {
  AosAnimationsMixin,
  AvailableLanguagesMixin,
  FooterEditLinkMixin,
  IsMobileMixin,
  LivePreviewMixin,
} from '~/mixins';
import CardList from '~/components/common/card-list.vue';
import TheSourceHero from '~/components/the-source/hero.vue';
import TheSourceForm from '~/components/the-source/form.vue';
import { LOCALES, THE_SOURCE_TYPES } from '~/common/constants';
import TheSourceResources from '~/components/the-source/resources.vue';

export default Vue.extend({
  components: {
    TheSourceResources,
    TheSourceForm,
    TheSourceHero,
    CardList,
  },
  mixins: [
    LivePreviewMixin,
    AosAnimationsMixin,
    FooterEditLinkMixin,
    IsMobileMixin,
    AvailableLanguagesMixin,
  ],
  layout: 'the-source',
  async middleware(context) {
    if (process.client) {
      return;
    }

    const { params } = context.route;
    const slug = Object.values(params).join('/');

    const page: CtfEntry<CtfTheSourceArticlePage> = await (<TheSourceService>(
      context.$theSourceService
    )).getArticleBySlug(`the-source${slug ? `/${slug}` : ''}`);

    context.$pageData = page;
    context.$availableLanguages = getAvailableLanguagesFromTags(
      page?.metadata?.tags,
    );
  },
  async asyncData({ $pageData, $availableLanguages }) {
    const article: CtfTheSourceArticlePage = $pageData.fields;

    return {
      article,
      ctfPage: $pageData,
      metadata: {
        title: article.headline,
        description: article.description,
        image_title: getUrlFromContentfulImage(article.heroImage),
      },
      availableLanguages: $availableLanguages,
    };
  },
  data() {
    return {
      types: THE_SOURCE_TYPES,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      this.metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
      this.availableLanguages,
    );
  },
  computed: {
    /**
     * The form appears with the next conditions:
     * - When the article is a "Guide" type
     * - When the article is a "Webinar" type and the date of the webinar is before the current date (Register)
     * - When the article is a "Webinar" type, the date of the webinar is past and the gated link exists in Contentful (Watch)
     */
    showForm() {
      const isGuide =
        this.article.type === THE_SOURCE_TYPES.GUIDE &&
        this.article.gatedAsset?.fields.gatedAssetLink;
      const isWebinar = this.article.type === THE_SOURCE_TYPES.WEBINAR;

      const currentDate = new Date();
      const articleDate = new Date(this.article.date);

      const isPastDate = articleDate < currentDate;

      const showWebinarForm =
        (isWebinar && !isPastDate) ||
        (isWebinar &&
          isPastDate &&
          this.article.gatedAsset?.fields.gatedAssetLink);

      return showWebinarForm || isGuide;
    },
  },
  beforeMount() {
    this.dataLayerScript();
  },
  mounted() {
    this.breakpoint = 1024;

    if (this.isPreview && this.ctfPage) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.ctfPage,
        callback: (updatedData) => (this.article = updatedData.fields),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
  methods: {
    /**
     * This Method obtains the category name from the route to avoid making another request to obtain the English title in localized pages
     */
    dataLayerScript() {
      const { path } = this.$route;
      const { locale } = this.$i18n;
      const { type, author, speakers } = this.article;

      const pathArray = path.split('/');
      const categoryIndex = locale === LOCALES.DEFAULT ? 2 : 3;
      const category = kebabToTitleCase(pathArray[categoryIndex] || '');

      const authorName =
        (type === THE_SOURCE_TYPES.WEBINAR
          ? speakers
              ?.map(
                (speaker: CtfEntry<CtfTheSourceAuthor>) => speaker.fields?.name,
              )
              .filter(Boolean)
              .join(', ')
          : author?.fields?.name) || '';

      const articleAnalytics = {
        author_name: authorName,
        type,
        category,
      };

      this.addDataLayer(articleAnalytics);
    },
    addDataLayer(articleAnalytics) {
      const domLoadIndex = window.dataLayer.findIndex(
        (item) => item.event === 'gtm.dom',
      );

      if (domLoadIndex !== -1) {
        window.dataLayer.splice(domLoadIndex, 0, articleAnalytics);
      } else {
        window.dataLayer.push(articleAnalytics);
      }
    },
  },
});
</script>

<template>
  <div class="article">
    <TheSourceHero :article="article" />
    <section>
      <SlpContainer v-if="isMobile && article.keyTakeaways">
        <CardList :list="article.keyTakeaways" />
      </SlpContainer>
      <!-- Article Body Start -->
      <SlpContainer class="article__container">
        <SlpRow>
          <SlpColumn :cols="8" size="lg">
            <div>
              <div
                class="article__body"
                v-html="$md.render(article.articleBody)"
              />
            </div>
            <div id="form">
              <TheSourceForm v-if="showForm" :article="article" />
            </div>
            <!-- External Gated Asset -->
            <div v-if="article.gatedAsset && article.type === types.REGULAR">
              <SlpTypography tag="h2" variant="heading5-bold" class="slp-my-24"
                >{{ $t('articles.nextSteps') }}
              </SlpTypography>
              <div class="article__gated">
                <SlpTypography tag="h4" variant="all-caps" class="slp-mb-24">{{
                  $t('articles.resources')
                }}</SlpTypography>
                <div class="slp-flex">
                  <SlpIcon name="lock" variant="product" class="slp-mr-4" />
                  <SlpTypography tag="h5" variant="all-caps" class="slp-mb-8">{{
                    $t(`articles.guide`)
                  }}</SlpTypography>
                </div>
                <SlpTypography tag="h5" variant="body2-bold" class="slp-mb-8">{{
                  article.gatedAsset.fields.title
                }}</SlpTypography>
                <SlpTypography
                  v-if="article.gatedAsset.fields.description"
                  tag="h5"
                  variant="body2"
                  >{{ article.gatedAsset.fields.description }}</SlpTypography
                >
                <SlpButton
                  v-if="article.gatedAsset.fields.gatedAssetLink"
                  :href="article.gatedAsset.fields.gatedAssetLink"
                  variant="tertiary"
                >
                  {{ $t('articles.access') }}
                </SlpButton>
              </div>
            </div>
          </SlpColumn>
          <SlpColumn :cols="4" size="lg" class="w-100">
            <div
              :class="[
                'article__side',
                {
                  'article__side--long':
                    article.speakers && article.speakers.length > 4,
                },
              ]"
            >
              <CardList
                v-if="!isMobile && article.keyTakeaways"
                :list="article.keyTakeaways"
              />
              <TheSourceResources
                v-if="article.type === types.REGULAR"
                :resources="article.category.fields.gatedAssets"
                surface-bg
              />
            </div>
          </SlpColumn>
        </SlpRow>
      </SlpContainer>
      <!-- Article Body End -->
    </section>
  </div>
</template>

<style scoped lang="scss">
$headings:
  'h1' $text-heading-3 $line-height-heading-3 $letter-spacing-heading-3-bold,
  'h2' $text-heading-2-mobile $line-height-heading-2-mobile
    $letter-spacing-heading-2-bold-mobile,
  'h3' $text-heading-3-mobile $line-height-heading-3-mobile
    $letter-spacing-heading-3-bold-mobile,
  'h4' $text-heading-4-mobile $line-height-heading-4-mobile
    $letter-spacing-heading-4-bold-mobile,
  'h5' $text-heading-5-mobile $line-height-heading-5-mobile
    $letter-spacing-heading-5-bold-mobile;

.article {
  &__container {
    padding-bottom: $spacing-32;
    padding-top: $spacing-16;

    @media (width > $breakpoint-md) {
      padding-bottom: $spacing-96;
    }
  }

  &__body {
    &:deep {
      p {
        padding-bottom: $spacing-16;

        &:last-of-type {
          padding-bottom: $spacing-32;
        }
      }

      @each $heading, $size, $line-height, $letter-spacing in $headings {
        p + #{$heading} {
          padding-top: $spacing-16;
        }

        #{$heading} {
          padding-bottom: $spacing-32;
          font-weight: $font-weight-bold;
          font-size: $size;
          line-height: $line-height;
          letter-spacing: $letter-spacing;
        }

        // Add no-anchor class to heading for removing anchor tag
        .no-anchor {
          .header-anchor {
            display: none;
          }
        }
      }

      // Articles Card using Markdown
      blockquote {
        background-color: $color-surface-100;
        padding: $spacing-24;
        border-radius: 8px;
        margin-bottom: $spacing-24;

        &:last-of-type {
          margin-bottom: 0;
        }

        p:last-of-type {
          padding-bottom: 0;
        }

        img {
          width: 100%;
          max-height: 371px;
        }

        @each $heading, $styles in $headings {
          #{$heading} {
            padding-bottom: $spacing-16;
          }
        }
      }

      img {
        width: 100%;
      }

      ol {
        list-style: decimal;
      }

      ul {
        list-style: disc;
      }

      ol,
      ul {
        padding-bottom: $spacing-24;
        padding-left: $spacing-24;
      }

      .video_container iframe {
        width: 100%;
        height: 460px;
        margin-bottom: 24px;
        @media (max-width: $breakpoint-lg) {
          height: 240px;
        }
      }

      // Articles Button using markdown
      .button {
        margin-top: $spacing-16;
        align-items: center;
        border-radius: 4px;
        display: inline-flex;
        font-size: $text-button-1;
        font-weight: $font-weight-bold;
        line-height: $line-height-button-1;
        min-width: 68px;
        padding: 11px $spacing-16;
        text-align: center;
        transition: background-color 0.3s cubic-bezier(0.7, 0, 0.3, 1);
        vertical-align: middle;
        background-color: $color-primary-200;
        border: 1px solid $color-primary-200;
        color: $color-primary-300;

        &:hover {
          background-color: white;
          color: $color-primary-200;
        }
      }
    }
  }

  &__side {
    width: 100%;

    @media (width >= $breakpoint-lg) {
      position: sticky;
      top: $spacing-32;
      margin-top: -190px;
      padding: 0 32px;
    }

    @media (width <= $breakpoint-md) {
      padding: 0;
      margin-top: $spacing-16;
    }
  }

  &__gated {
    background-color: $color-surface-100;
    border-radius: 8px;
    padding: $spacing-24;

    &:first-child {
      border-bottom: 1px solid $color-surface-300;
    }

    .slp-btn {
      &:hover {
        color: $color-text-link-100;
        text-decoration-color: $color-text-link-100;
      }
    }
  }
}
</style>
